# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetInspectionAllPredefinedControlsResult',
    'AwaitableGetInspectionAllPredefinedControlsResult',
    'get_inspection_all_predefined_controls',
    'get_inspection_all_predefined_controls_output',
]

@pulumi.output_type
class GetInspectionAllPredefinedControlsResult:
    """
    A collection of values returned by getInspectionAllPredefinedControls.
    """
    def __init__(__self__, group_name=None, id=None, lists=None, version=None):
        if group_name and not isinstance(group_name, str):
            raise TypeError("Expected argument 'group_name' to be a str")
        pulumi.set(__self__, "group_name", group_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if version and not isinstance(version, str):
            raise TypeError("Expected argument 'version' to be a str")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="groupName")
    def group_name(self) -> Optional[str]:
        return pulumi.get(self, "group_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetInspectionAllPredefinedControlsListResult']:
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter
    def version(self) -> str:
        return pulumi.get(self, "version")


class AwaitableGetInspectionAllPredefinedControlsResult(GetInspectionAllPredefinedControlsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInspectionAllPredefinedControlsResult(
            group_name=self.group_name,
            id=self.id,
            lists=self.lists,
            version=self.version)


def get_inspection_all_predefined_controls(group_name: Optional[str] = None,
                                           version: Optional[str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInspectionAllPredefinedControlsResult:
    """
    * [Official documentation](https://help.zscaler.com/zpa/about-custom-controls)
    * [API documentation](https://help.zscaler.com/zpa/configuring-appprotection-controls-using-api)

    Use the **zpa_inspection_all_predefined_controls** data source to get information about all OWASP predefined control and prefedined control version by group name. The `Preprocessors` predefined control is the default predefined control, This data source is always required, when creating an inspection profile.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_zpa as zpa

    this = zpa.get_inspection_all_predefined_controls(group_name="Preprocessors",
        version="OWASP_CRS/3.3.0")
    ```
    <!--End PulumiCodeChooser -->
    """
    __args__ = dict()
    __args__['groupName'] = group_name
    __args__['version'] = version
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zpa:index/getInspectionAllPredefinedControls:getInspectionAllPredefinedControls', __args__, opts=opts, typ=GetInspectionAllPredefinedControlsResult).value

    return AwaitableGetInspectionAllPredefinedControlsResult(
        group_name=pulumi.get(__ret__, 'group_name'),
        id=pulumi.get(__ret__, 'id'),
        lists=pulumi.get(__ret__, 'lists'),
        version=pulumi.get(__ret__, 'version'))


@_utilities.lift_output_func(get_inspection_all_predefined_controls)
def get_inspection_all_predefined_controls_output(group_name: Optional[pulumi.Input[Optional[str]]] = None,
                                                  version: Optional[pulumi.Input[str]] = None,
                                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInspectionAllPredefinedControlsResult]:
    """
    * [Official documentation](https://help.zscaler.com/zpa/about-custom-controls)
    * [API documentation](https://help.zscaler.com/zpa/configuring-appprotection-controls-using-api)

    Use the **zpa_inspection_all_predefined_controls** data source to get information about all OWASP predefined control and prefedined control version by group name. The `Preprocessors` predefined control is the default predefined control, This data source is always required, when creating an inspection profile.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_zpa as zpa

    this = zpa.get_inspection_all_predefined_controls(group_name="Preprocessors",
        version="OWASP_CRS/3.3.0")
    ```
    <!--End PulumiCodeChooser -->
    """
    ...
