# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPRACredentialResult',
    'AwaitableGetPRACredentialResult',
    'get_pra_credential',
    'get_pra_credential_output',
]

@pulumi.output_type
class GetPRACredentialResult:
    """
    A collection of values returned by getPRACredential.
    """
    def __init__(__self__, creation_time=None, credential_type=None, description=None, id=None, last_credential_reset_time=None, microtenant_id=None, microtenant_name=None, modified_by=None, modified_time=None, name=None, user_domain=None, username=None):
        if creation_time and not isinstance(creation_time, str):
            raise TypeError("Expected argument 'creation_time' to be a str")
        pulumi.set(__self__, "creation_time", creation_time)
        if credential_type and not isinstance(credential_type, str):
            raise TypeError("Expected argument 'credential_type' to be a str")
        pulumi.set(__self__, "credential_type", credential_type)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_credential_reset_time and not isinstance(last_credential_reset_time, str):
            raise TypeError("Expected argument 'last_credential_reset_time' to be a str")
        pulumi.set(__self__, "last_credential_reset_time", last_credential_reset_time)
        if microtenant_id and not isinstance(microtenant_id, str):
            raise TypeError("Expected argument 'microtenant_id' to be a str")
        pulumi.set(__self__, "microtenant_id", microtenant_id)
        if microtenant_name and not isinstance(microtenant_name, str):
            raise TypeError("Expected argument 'microtenant_name' to be a str")
        pulumi.set(__self__, "microtenant_name", microtenant_name)
        if modified_by and not isinstance(modified_by, str):
            raise TypeError("Expected argument 'modified_by' to be a str")
        pulumi.set(__self__, "modified_by", modified_by)
        if modified_time and not isinstance(modified_time, str):
            raise TypeError("Expected argument 'modified_time' to be a str")
        pulumi.set(__self__, "modified_time", modified_time)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if user_domain and not isinstance(user_domain, str):
            raise TypeError("Expected argument 'user_domain' to be a str")
        pulumi.set(__self__, "user_domain", user_domain)
        if username and not isinstance(username, str):
            raise TypeError("Expected argument 'username' to be a str")
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="creationTime")
    def creation_time(self) -> str:
        return pulumi.get(self, "creation_time")

    @property
    @pulumi.getter(name="credentialType")
    def credential_type(self) -> str:
        return pulumi.get(self, "credential_type")

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastCredentialResetTime")
    def last_credential_reset_time(self) -> str:
        return pulumi.get(self, "last_credential_reset_time")

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> str:
        return pulumi.get(self, "microtenant_id")

    @property
    @pulumi.getter(name="microtenantName")
    def microtenant_name(self) -> str:
        return pulumi.get(self, "microtenant_name")

    @property
    @pulumi.getter(name="modifiedBy")
    def modified_by(self) -> str:
        return pulumi.get(self, "modified_by")

    @property
    @pulumi.getter(name="modifiedTime")
    def modified_time(self) -> str:
        return pulumi.get(self, "modified_time")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        - (String) The name of the privileged credential.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="userDomain")
    def user_domain(self) -> str:
        return pulumi.get(self, "user_domain")

    @property
    @pulumi.getter
    def username(self) -> str:
        return pulumi.get(self, "username")


class AwaitableGetPRACredentialResult(GetPRACredentialResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPRACredentialResult(
            creation_time=self.creation_time,
            credential_type=self.credential_type,
            description=self.description,
            id=self.id,
            last_credential_reset_time=self.last_credential_reset_time,
            microtenant_id=self.microtenant_id,
            microtenant_name=self.microtenant_name,
            modified_by=self.modified_by,
            modified_time=self.modified_time,
            name=self.name,
            user_domain=self.user_domain,
            username=self.username)


def get_pra_credential(id: Optional[str] = None,
                       name: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPRACredentialResult:
    """
    * [Official documentation](https://help.zscaler.com/zpa/about-privileged-credentials)
    * [API documentation](https://help.zscaler.com/zpa/configuring-privileged-credentials-using-api)

    The **zpa_pra_credential_controller** resource creates a privileged remote access credential in the Zscaler Private Access cloud. This resource can then be referenced in an privileged access policy resource.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import zscaler_pulumi_zpa as zpa

    # Retrieves PRA Credential By ID
    this = zpa.PRACredential("this")
    ```
    <!--End PulumiCodeChooser -->


    :param str name: - (String) The name of the privileged credential.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zpa:index/getPRACredential:getPRACredential', __args__, opts=opts, typ=GetPRACredentialResult).value

    return AwaitableGetPRACredentialResult(
        creation_time=pulumi.get(__ret__, 'creation_time'),
        credential_type=pulumi.get(__ret__, 'credential_type'),
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        last_credential_reset_time=pulumi.get(__ret__, 'last_credential_reset_time'),
        microtenant_id=pulumi.get(__ret__, 'microtenant_id'),
        microtenant_name=pulumi.get(__ret__, 'microtenant_name'),
        modified_by=pulumi.get(__ret__, 'modified_by'),
        modified_time=pulumi.get(__ret__, 'modified_time'),
        name=pulumi.get(__ret__, 'name'),
        user_domain=pulumi.get(__ret__, 'user_domain'),
        username=pulumi.get(__ret__, 'username'))


@_utilities.lift_output_func(get_pra_credential)
def get_pra_credential_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                              name: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPRACredentialResult]:
    """
    * [Official documentation](https://help.zscaler.com/zpa/about-privileged-credentials)
    * [API documentation](https://help.zscaler.com/zpa/configuring-privileged-credentials-using-api)

    The **zpa_pra_credential_controller** resource creates a privileged remote access credential in the Zscaler Private Access cloud. This resource can then be referenced in an privileged access policy resource.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import zscaler_pulumi_zpa as zpa

    # Retrieves PRA Credential By ID
    this = zpa.PRACredential("this")
    ```
    <!--End PulumiCodeChooser -->


    :param str name: - (String) The name of the privileged credential.
    """
    ...
