# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ServiceEdgeGroupArgs', 'ServiceEdgeGroup']

@pulumi.input_type
class ServiceEdgeGroupArgs:
    def __init__(__self__, *,
                 latitude: pulumi.Input[str],
                 location: pulumi.Input[str],
                 longitude: pulumi.Input[str],
                 city_country: Optional[pulumi.Input[str]] = None,
                 country_code: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 is_public: Optional[pulumi.Input[bool]] = None,
                 microtenant_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 override_version_profile: Optional[pulumi.Input[bool]] = None,
                 service_edges: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupServiceEdgeArgs']]]] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]] = None,
                 upgrade_day: Optional[pulumi.Input[str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[str]] = None,
                 version_profile_id: Optional[pulumi.Input[str]] = None,
                 version_profile_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ServiceEdgeGroup resource.
        :param pulumi.Input[str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[str] location: Location for the Service Edge Group.
        :param pulumi.Input[str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[str] description: Description of the Service Edge Group.
        :param pulumi.Input[bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[str] name: Name of the Service Edge Group.
        :param pulumi.Input[bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[str] version_profile_id: ID of the version profile.
        :param pulumi.Input[str] version_profile_name: ID of the version profile.
        """
        pulumi.set(__self__, "latitude", latitude)
        pulumi.set(__self__, "location", location)
        pulumi.set(__self__, "longitude", longitude)
        if city_country is not None:
            pulumi.set(__self__, "city_country", city_country)
        if country_code is not None:
            pulumi.set(__self__, "country_code", country_code)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if is_public is not None:
            pulumi.set(__self__, "is_public", is_public)
        if microtenant_id is not None:
            pulumi.set(__self__, "microtenant_id", microtenant_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if override_version_profile is not None:
            pulumi.set(__self__, "override_version_profile", override_version_profile)
        if service_edges is not None:
            pulumi.set(__self__, "service_edges", service_edges)
        if trusted_networks is not None:
            pulumi.set(__self__, "trusted_networks", trusted_networks)
        if upgrade_day is not None:
            pulumi.set(__self__, "upgrade_day", upgrade_day)
        if upgrade_time_in_secs is not None:
            pulumi.set(__self__, "upgrade_time_in_secs", upgrade_time_in_secs)
        if version_profile_id is not None:
            pulumi.set(__self__, "version_profile_id", version_profile_id)
        if version_profile_name is not None:
            pulumi.set(__self__, "version_profile_name", version_profile_name)

    @property
    @pulumi.getter
    def latitude(self) -> pulumi.Input[str]:
        """
        Latitude for the Service Edge Group.
        """
        return pulumi.get(self, "latitude")

    @latitude.setter
    def latitude(self, value: pulumi.Input[str]):
        pulumi.set(self, "latitude", value)

    @property
    @pulumi.getter
    def location(self) -> pulumi.Input[str]:
        """
        Location for the Service Edge Group.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: pulumi.Input[str]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def longitude(self) -> pulumi.Input[str]:
        """
        Longitude for the Service Edge Group.
        """
        return pulumi.get(self, "longitude")

    @longitude.setter
    def longitude(self, value: pulumi.Input[str]):
        pulumi.set(self, "longitude", value)

    @property
    @pulumi.getter(name="cityCountry")
    def city_country(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "city_country")

    @city_country.setter
    def city_country(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "city_country", value)

    @property
    @pulumi.getter(name="countryCode")
    def country_code(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "country_code")

    @country_code.setter
    def country_code(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "country_code", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the Service Edge Group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this Service Edge Group is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="isPublic")
    def is_public(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable or disable public access for the Service Edge Group.
        """
        return pulumi.get(self, "is_public")

    @is_public.setter
    def is_public(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_public", value)

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "microtenant_id")

    @microtenant_id.setter
    def microtenant_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "microtenant_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the Service Edge Group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="overrideVersionProfile")
    def override_version_profile(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the default version profile of the App Connector Group is applied or overridden.
        """
        return pulumi.get(self, "override_version_profile")

    @override_version_profile.setter
    def override_version_profile(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "override_version_profile", value)

    @property
    @pulumi.getter(name="serviceEdges")
    def service_edges(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupServiceEdgeArgs']]]]:
        return pulumi.get(self, "service_edges")

    @service_edges.setter
    def service_edges(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupServiceEdgeArgs']]]]):
        pulumi.set(self, "service_edges", value)

    @property
    @pulumi.getter(name="trustedNetworks")
    def trusted_networks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]:
        """
        List of trusted network IDs.
        """
        return pulumi.get(self, "trusted_networks")

    @trusted_networks.setter
    def trusted_networks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]):
        pulumi.set(self, "trusted_networks", value)

    @property
    @pulumi.getter(name="upgradeDay")
    def upgrade_day(self) -> Optional[pulumi.Input[str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        """
        return pulumi.get(self, "upgrade_day")

    @upgrade_day.setter
    def upgrade_day(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "upgrade_day", value)

    @property
    @pulumi.getter(name="upgradeTimeInSecs")
    def upgrade_time_in_secs(self) -> Optional[pulumi.Input[str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        """
        return pulumi.get(self, "upgrade_time_in_secs")

    @upgrade_time_in_secs.setter
    def upgrade_time_in_secs(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "upgrade_time_in_secs", value)

    @property
    @pulumi.getter(name="versionProfileId")
    def version_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_id")

    @version_profile_id.setter
    def version_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version_profile_id", value)

    @property
    @pulumi.getter(name="versionProfileName")
    def version_profile_name(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_name")

    @version_profile_name.setter
    def version_profile_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version_profile_name", value)


@pulumi.input_type
class _ServiceEdgeGroupState:
    def __init__(__self__, *,
                 city_country: Optional[pulumi.Input[str]] = None,
                 country_code: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 is_public: Optional[pulumi.Input[bool]] = None,
                 latitude: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 longitude: Optional[pulumi.Input[str]] = None,
                 microtenant_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 override_version_profile: Optional[pulumi.Input[bool]] = None,
                 service_edges: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupServiceEdgeArgs']]]] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]] = None,
                 upgrade_day: Optional[pulumi.Input[str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[str]] = None,
                 version_profile_id: Optional[pulumi.Input[str]] = None,
                 version_profile_name: Optional[pulumi.Input[str]] = None,
                 version_profile_visibility_scope: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ServiceEdgeGroup resources.
        :param pulumi.Input[str] description: Description of the Service Edge Group.
        :param pulumi.Input[bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[str] location: Location for the Service Edge Group.
        :param pulumi.Input[str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[str] name: Name of the Service Edge Group.
        :param pulumi.Input[bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[str] version_profile_id: ID of the version profile.
        :param pulumi.Input[str] version_profile_name: ID of the version profile.
        :param pulumi.Input[str] version_profile_visibility_scope: ID of the version profile.
        """
        if city_country is not None:
            pulumi.set(__self__, "city_country", city_country)
        if country_code is not None:
            pulumi.set(__self__, "country_code", country_code)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if is_public is not None:
            pulumi.set(__self__, "is_public", is_public)
        if latitude is not None:
            pulumi.set(__self__, "latitude", latitude)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if longitude is not None:
            pulumi.set(__self__, "longitude", longitude)
        if microtenant_id is not None:
            pulumi.set(__self__, "microtenant_id", microtenant_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if override_version_profile is not None:
            pulumi.set(__self__, "override_version_profile", override_version_profile)
        if service_edges is not None:
            pulumi.set(__self__, "service_edges", service_edges)
        if trusted_networks is not None:
            pulumi.set(__self__, "trusted_networks", trusted_networks)
        if upgrade_day is not None:
            pulumi.set(__self__, "upgrade_day", upgrade_day)
        if upgrade_time_in_secs is not None:
            pulumi.set(__self__, "upgrade_time_in_secs", upgrade_time_in_secs)
        if version_profile_id is not None:
            pulumi.set(__self__, "version_profile_id", version_profile_id)
        if version_profile_name is not None:
            pulumi.set(__self__, "version_profile_name", version_profile_name)
        if version_profile_visibility_scope is not None:
            pulumi.set(__self__, "version_profile_visibility_scope", version_profile_visibility_scope)

    @property
    @pulumi.getter(name="cityCountry")
    def city_country(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "city_country")

    @city_country.setter
    def city_country(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "city_country", value)

    @property
    @pulumi.getter(name="countryCode")
    def country_code(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "country_code")

    @country_code.setter
    def country_code(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "country_code", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the Service Edge Group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this Service Edge Group is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="isPublic")
    def is_public(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable or disable public access for the Service Edge Group.
        """
        return pulumi.get(self, "is_public")

    @is_public.setter
    def is_public(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_public", value)

    @property
    @pulumi.getter
    def latitude(self) -> Optional[pulumi.Input[str]]:
        """
        Latitude for the Service Edge Group.
        """
        return pulumi.get(self, "latitude")

    @latitude.setter
    def latitude(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "latitude", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        Location for the Service Edge Group.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def longitude(self) -> Optional[pulumi.Input[str]]:
        """
        Longitude for the Service Edge Group.
        """
        return pulumi.get(self, "longitude")

    @longitude.setter
    def longitude(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "longitude", value)

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "microtenant_id")

    @microtenant_id.setter
    def microtenant_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "microtenant_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the Service Edge Group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="overrideVersionProfile")
    def override_version_profile(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the default version profile of the App Connector Group is applied or overridden.
        """
        return pulumi.get(self, "override_version_profile")

    @override_version_profile.setter
    def override_version_profile(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "override_version_profile", value)

    @property
    @pulumi.getter(name="serviceEdges")
    def service_edges(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupServiceEdgeArgs']]]]:
        return pulumi.get(self, "service_edges")

    @service_edges.setter
    def service_edges(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupServiceEdgeArgs']]]]):
        pulumi.set(self, "service_edges", value)

    @property
    @pulumi.getter(name="trustedNetworks")
    def trusted_networks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]:
        """
        List of trusted network IDs.
        """
        return pulumi.get(self, "trusted_networks")

    @trusted_networks.setter
    def trusted_networks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]):
        pulumi.set(self, "trusted_networks", value)

    @property
    @pulumi.getter(name="upgradeDay")
    def upgrade_day(self) -> Optional[pulumi.Input[str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        """
        return pulumi.get(self, "upgrade_day")

    @upgrade_day.setter
    def upgrade_day(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "upgrade_day", value)

    @property
    @pulumi.getter(name="upgradeTimeInSecs")
    def upgrade_time_in_secs(self) -> Optional[pulumi.Input[str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        """
        return pulumi.get(self, "upgrade_time_in_secs")

    @upgrade_time_in_secs.setter
    def upgrade_time_in_secs(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "upgrade_time_in_secs", value)

    @property
    @pulumi.getter(name="versionProfileId")
    def version_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_id")

    @version_profile_id.setter
    def version_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version_profile_id", value)

    @property
    @pulumi.getter(name="versionProfileName")
    def version_profile_name(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_name")

    @version_profile_name.setter
    def version_profile_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version_profile_name", value)

    @property
    @pulumi.getter(name="versionProfileVisibilityScope")
    def version_profile_visibility_scope(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_visibility_scope")

    @version_profile_visibility_scope.setter
    def version_profile_visibility_scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version_profile_visibility_scope", value)


class ServiceEdgeGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 city_country: Optional[pulumi.Input[str]] = None,
                 country_code: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 is_public: Optional[pulumi.Input[bool]] = None,
                 latitude: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 longitude: Optional[pulumi.Input[str]] = None,
                 microtenant_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 override_version_profile: Optional[pulumi.Input[bool]] = None,
                 service_edges: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupServiceEdgeArgs']]]]] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupTrustedNetworkArgs']]]]] = None,
                 upgrade_day: Optional[pulumi.Input[str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[str]] = None,
                 version_profile_id: Optional[pulumi.Input[str]] = None,
                 version_profile_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-zpa-private-service-edge-groups)
        * [API documentation](https://help.zscaler.com/zpa/configuring-zpa-private-service-edge-groups-using-api)

        The **zpa_service_edge_group** resource creates a service edge group in the Zscaler Private Access cloud. This resource can then be referenced in a service edge connector.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - Trusted Network
        service_edge_group_sjc = zpa.ServiceEdgeGroup("serviceEdgeGroupSjc",
            description="Service Edge Group in San Jose",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="37.3382082",
            longitude="-121.8863286",
            location="San Jose, CA, USA",
            version_profile_name="New Release",
            trusted_networks=[zpa.ServiceEdgeGroupTrustedNetworkArgs(
                ids=[data["zpa_trusted_network"]["example"]["id"]],
            )])
        ```
        <!--End PulumiCodeChooser -->

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - No Trusted Network
        service_edge_group_nyc = zpa.ServiceEdgeGroup("serviceEdgeGroupNyc",
            description="Service Edge Group in New York",
            enabled=True,
            is_public=True,
            latitude="40.7128",
            location="New York, NY, USA",
            longitude="-73.935242",
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            version_profile_name="New Release")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        Service Edge Group can be imported; use `<SERVER EDGE GROUP ID>` or `<SERVER EDGE GROUP NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_id>
        ```

        or

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_name>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description of the Service Edge Group.
        :param pulumi.Input[bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[str] location: Location for the Service Edge Group.
        :param pulumi.Input[str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[str] name: Name of the Service Edge Group.
        :param pulumi.Input[bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupTrustedNetworkArgs']]]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[str] version_profile_id: ID of the version profile.
        :param pulumi.Input[str] version_profile_name: ID of the version profile.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ServiceEdgeGroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-zpa-private-service-edge-groups)
        * [API documentation](https://help.zscaler.com/zpa/configuring-zpa-private-service-edge-groups-using-api)

        The **zpa_service_edge_group** resource creates a service edge group in the Zscaler Private Access cloud. This resource can then be referenced in a service edge connector.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - Trusted Network
        service_edge_group_sjc = zpa.ServiceEdgeGroup("serviceEdgeGroupSjc",
            description="Service Edge Group in San Jose",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="37.3382082",
            longitude="-121.8863286",
            location="San Jose, CA, USA",
            version_profile_name="New Release",
            trusted_networks=[zpa.ServiceEdgeGroupTrustedNetworkArgs(
                ids=[data["zpa_trusted_network"]["example"]["id"]],
            )])
        ```
        <!--End PulumiCodeChooser -->

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - No Trusted Network
        service_edge_group_nyc = zpa.ServiceEdgeGroup("serviceEdgeGroupNyc",
            description="Service Edge Group in New York",
            enabled=True,
            is_public=True,
            latitude="40.7128",
            location="New York, NY, USA",
            longitude="-73.935242",
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            version_profile_name="New Release")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        Service Edge Group can be imported; use `<SERVER EDGE GROUP ID>` or `<SERVER EDGE GROUP NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_id>
        ```

        or

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_name>
        ```

        :param str resource_name: The name of the resource.
        :param ServiceEdgeGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ServiceEdgeGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 city_country: Optional[pulumi.Input[str]] = None,
                 country_code: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 is_public: Optional[pulumi.Input[bool]] = None,
                 latitude: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 longitude: Optional[pulumi.Input[str]] = None,
                 microtenant_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 override_version_profile: Optional[pulumi.Input[bool]] = None,
                 service_edges: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupServiceEdgeArgs']]]]] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupTrustedNetworkArgs']]]]] = None,
                 upgrade_day: Optional[pulumi.Input[str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[str]] = None,
                 version_profile_id: Optional[pulumi.Input[str]] = None,
                 version_profile_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ServiceEdgeGroupArgs.__new__(ServiceEdgeGroupArgs)

            __props__.__dict__["city_country"] = city_country
            __props__.__dict__["country_code"] = country_code
            __props__.__dict__["description"] = description
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["is_public"] = is_public
            if latitude is None and not opts.urn:
                raise TypeError("Missing required property 'latitude'")
            __props__.__dict__["latitude"] = latitude
            if location is None and not opts.urn:
                raise TypeError("Missing required property 'location'")
            __props__.__dict__["location"] = location
            if longitude is None and not opts.urn:
                raise TypeError("Missing required property 'longitude'")
            __props__.__dict__["longitude"] = longitude
            __props__.__dict__["microtenant_id"] = microtenant_id
            __props__.__dict__["name"] = name
            __props__.__dict__["override_version_profile"] = override_version_profile
            __props__.__dict__["service_edges"] = service_edges
            __props__.__dict__["trusted_networks"] = trusted_networks
            __props__.__dict__["upgrade_day"] = upgrade_day
            __props__.__dict__["upgrade_time_in_secs"] = upgrade_time_in_secs
            __props__.__dict__["version_profile_id"] = version_profile_id
            __props__.__dict__["version_profile_name"] = version_profile_name
            __props__.__dict__["version_profile_visibility_scope"] = None
        super(ServiceEdgeGroup, __self__).__init__(
            'zpa:index/serviceEdgeGroup:ServiceEdgeGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            city_country: Optional[pulumi.Input[str]] = None,
            country_code: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            is_public: Optional[pulumi.Input[bool]] = None,
            latitude: Optional[pulumi.Input[str]] = None,
            location: Optional[pulumi.Input[str]] = None,
            longitude: Optional[pulumi.Input[str]] = None,
            microtenant_id: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            override_version_profile: Optional[pulumi.Input[bool]] = None,
            service_edges: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupServiceEdgeArgs']]]]] = None,
            trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupTrustedNetworkArgs']]]]] = None,
            upgrade_day: Optional[pulumi.Input[str]] = None,
            upgrade_time_in_secs: Optional[pulumi.Input[str]] = None,
            version_profile_id: Optional[pulumi.Input[str]] = None,
            version_profile_name: Optional[pulumi.Input[str]] = None,
            version_profile_visibility_scope: Optional[pulumi.Input[str]] = None) -> 'ServiceEdgeGroup':
        """
        Get an existing ServiceEdgeGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description of the Service Edge Group.
        :param pulumi.Input[bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[str] location: Location for the Service Edge Group.
        :param pulumi.Input[str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[str] name: Name of the Service Edge Group.
        :param pulumi.Input[bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceEdgeGroupTrustedNetworkArgs']]]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[str] version_profile_id: ID of the version profile.
        :param pulumi.Input[str] version_profile_name: ID of the version profile.
        :param pulumi.Input[str] version_profile_visibility_scope: ID of the version profile.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ServiceEdgeGroupState.__new__(_ServiceEdgeGroupState)

        __props__.__dict__["city_country"] = city_country
        __props__.__dict__["country_code"] = country_code
        __props__.__dict__["description"] = description
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["is_public"] = is_public
        __props__.__dict__["latitude"] = latitude
        __props__.__dict__["location"] = location
        __props__.__dict__["longitude"] = longitude
        __props__.__dict__["microtenant_id"] = microtenant_id
        __props__.__dict__["name"] = name
        __props__.__dict__["override_version_profile"] = override_version_profile
        __props__.__dict__["service_edges"] = service_edges
        __props__.__dict__["trusted_networks"] = trusted_networks
        __props__.__dict__["upgrade_day"] = upgrade_day
        __props__.__dict__["upgrade_time_in_secs"] = upgrade_time_in_secs
        __props__.__dict__["version_profile_id"] = version_profile_id
        __props__.__dict__["version_profile_name"] = version_profile_name
        __props__.__dict__["version_profile_visibility_scope"] = version_profile_visibility_scope
        return ServiceEdgeGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cityCountry")
    def city_country(self) -> pulumi.Output[str]:
        return pulumi.get(self, "city_country")

    @property
    @pulumi.getter(name="countryCode")
    def country_code(self) -> pulumi.Output[str]:
        return pulumi.get(self, "country_code")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of the Service Edge Group.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether this Service Edge Group is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="isPublic")
    def is_public(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable or disable public access for the Service Edge Group.
        """
        return pulumi.get(self, "is_public")

    @property
    @pulumi.getter
    def latitude(self) -> pulumi.Output[str]:
        """
        Latitude for the Service Edge Group.
        """
        return pulumi.get(self, "latitude")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        Location for the Service Edge Group.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def longitude(self) -> pulumi.Output[str]:
        """
        Longitude for the Service Edge Group.
        """
        return pulumi.get(self, "longitude")

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "microtenant_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the Service Edge Group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="overrideVersionProfile")
    def override_version_profile(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether the default version profile of the App Connector Group is applied or overridden.
        """
        return pulumi.get(self, "override_version_profile")

    @property
    @pulumi.getter(name="serviceEdges")
    def service_edges(self) -> pulumi.Output[Sequence['outputs.ServiceEdgeGroupServiceEdge']]:
        return pulumi.get(self, "service_edges")

    @property
    @pulumi.getter(name="trustedNetworks")
    def trusted_networks(self) -> pulumi.Output[Sequence['outputs.ServiceEdgeGroupTrustedNetwork']]:
        """
        List of trusted network IDs.
        """
        return pulumi.get(self, "trusted_networks")

    @property
    @pulumi.getter(name="upgradeDay")
    def upgrade_day(self) -> pulumi.Output[Optional[str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        """
        return pulumi.get(self, "upgrade_day")

    @property
    @pulumi.getter(name="upgradeTimeInSecs")
    def upgrade_time_in_secs(self) -> pulumi.Output[Optional[str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        """
        return pulumi.get(self, "upgrade_time_in_secs")

    @property
    @pulumi.getter(name="versionProfileId")
    def version_profile_id(self) -> pulumi.Output[str]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_id")

    @property
    @pulumi.getter(name="versionProfileName")
    def version_profile_name(self) -> pulumi.Output[str]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_name")

    @property
    @pulumi.getter(name="versionProfileVisibilityScope")
    def version_profile_visibility_scope(self) -> pulumi.Output[str]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_visibility_scope")

